GNU bug report logs - #9712
defcustom's initial value expression is not byte-compiled

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Severity: wishlist; Reported by: "Drew Adams" <drew.adams@HIDDEN>; dated Sun, 9 Oct 2011 20:44:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 9712 <at> debbugs.gnu.org:


Received: (at 9712) by debbugs.gnu.org; 11 Oct 2011 14:35:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 11 10:35:52 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RDdQu-0007xR-9R
	for submit <at> debbugs.gnu.org; Tue, 11 Oct 2011 10:35:52 -0400
Received: from rcsinet15.oracle.com ([148.87.113.117])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <drew.adams@HIDDEN>) id 1RDdQr-0007x3-KX
	for 9712 <at> debbugs.gnu.org; Tue, 11 Oct 2011 10:35:50 -0400
Received: from ucsinet24.oracle.com (ucsinet24.oracle.com [156.151.31.67])
	by rcsinet15.oracle.com (Switch-3.4.4/Switch-3.4.4) with ESMTP id
	p9BEZO8K027792
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=FAIL);
	Tue, 11 Oct 2011 14:35:26 GMT
Received: from acsmt358.oracle.com (acsmt358.oracle.com [141.146.40.158])
	by ucsinet24.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id
	p9BETRXX018124
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO);
	Tue, 11 Oct 2011 14:29:28 GMT
Received: from abhmt120.oracle.com (abhmt120.oracle.com [141.146.116.72])
	by acsmt358.oracle.com (8.12.11.20060308/8.12.11) with ESMTP id
	p9BEZIKH019095; Tue, 11 Oct 2011 09:35:18 -0500
Received: from dradamslap1 (/10.159.50.234)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Tue, 11 Oct 2011 07:35:17 -0700
From: "Drew Adams" <drew.adams@HIDDEN>
To: "'Stefan Monnier'" <monnier@HIDDEN>
References: <F53B306DF56A443A953E84CE5AFA8D33@HIDDEN><jwvy5ws2rz0.fsf-monnier+emacs@HIDDEN><7D2DB4482840400D81CC74F60D0091DC@HIDDEN><jwvsjn0yv3l.fsf-monnier+emacs@HIDDEN><E46291070877490CB64D692C8E3D00C8@HIDDEN>
	<jwvipnvhey9.fsf-monnier+emacs@HIDDEN>
Subject: RE: bug#9712: 24.0.50; doc about byte-compiling `defcustom'
Date: Tue, 11 Oct 2011 07:35:15 -0700
Message-ID: <D0989B26851948F6AFCE09BD5F793AB9@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
In-Reply-To: <jwvipnvhey9.fsf-monnier+emacs@HIDDEN>
Thread-Index: AcyIFECDL36v4SdpQtq2WjuvEFXf5AADi40Q
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.6109
X-Source-IP: ucsinet24.oracle.com [156.151.31.67]
X-CT-RefId: str=0001.0A090202.4E94542E.0172,ss=1,re=0.000,fgs=0
X-Spam-Score: -6.2 (------)
X-Debbugs-Envelope-To: 9712
Cc: 9712 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.2 (------)

> >> > The bug has been there for multiple major Emacs releases
> >> > now - a decade or so, and appears to have been introduced 
> >> > intentionally.  If there is no plan to fix it soon,
> >> > perhaps the info that is in the comments should at least
> >> > be conveyed to users.
> >> >
> >> The introduction of lexical-binding makes this issue more serious
> >> because this code does not obey the lexical-binding variable (and
> >> escapes the sanity checks of cconv.el, hence occasionally hiding
> >> problems when converting to lexical-binding).
> >
> > So will this be fixed in Emacs 24.1 then?  +1
> 
> No.

Why not, especially since 24.1 introduces generalized lexical binding, which
"makes this issue more serious"?  What's the hurry to shove 24.1 out the door?

And it seems like if you insist on only going for halfway measures in 24.1 then
it would be better for users to see the constant value in Customize (no big
deal) that it is for byte-compilation not to work properly and for the doc to be
contradicted in several places (defcustom, eval-when-compile,...).





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#9712; Package emacs. Full text available.

Message received at 9712 <at> debbugs.gnu.org:


Received: (at 9712) by debbugs.gnu.org; 11 Oct 2011 12:48:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 11 08:48:55 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RDblP-0005JM-5B
	for submit <at> debbugs.gnu.org; Tue, 11 Oct 2011 08:48:55 -0400
Received: from ironport2-out.teksavvy.com ([206.248.154.183]
	helo=ironport2-out.pppoe.ca)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <monnier@HIDDEN>) id 1RDblN-0005J8-JL
	for 9712 <at> debbugs.gnu.org; Tue, 11 Oct 2011 08:48:53 -0400
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: Av0EALQ6lE5FxJoX/2dsb2JhbABDqCWBBoFTAQEEAVYjEAs0EhQYDSSIEblhh0wEoR6ERQ
X-IronPort-AV: E=Sophos;i="4.68,523,1312171200"; d="scan'208";a="141149076"
Received: from 69-196-154-23.dsl.teksavvy.com (HELO pastel.home)
	([69.196.154.23])
	by ironport2-out.pppoe.ca with ESMTP/TLS/ADH-AES256-SHA;
	11 Oct 2011 08:48:31 -0400
Received: by pastel.home (Postfix, from userid 20848)
	id DA7805921E; Tue, 11 Oct 2011 08:48:30 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: "Drew Adams" <drew.adams@HIDDEN>
Subject: Re: bug#9712: 24.0.50; doc about byte-compiling `defcustom'
Message-ID: <jwvipnvhey9.fsf-monnier+emacs@HIDDEN>
References: <F53B306DF56A443A953E84CE5AFA8D33@HIDDEN>
	<jwvy5ws2rz0.fsf-monnier+emacs@HIDDEN>
	<7D2DB4482840400D81CC74F60D0091DC@HIDDEN>
	<jwvsjn0yv3l.fsf-monnier+emacs@HIDDEN>
	<E46291070877490CB64D692C8E3D00C8@HIDDEN>
Date: Tue, 11 Oct 2011 08:48:30 -0400
In-Reply-To: <E46291070877490CB64D692C8E3D00C8@HIDDEN> (Drew Adams's
	message of "Mon, 10 Oct 2011 22:40:19 -0700")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.90 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.6 (--)
X-Debbugs-Envelope-To: 9712
Cc: 9712 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.6 (--)

>> > The bug has been there for multiple major Emacs releases now -
>> > a decade or so, and appears to have been introduced intentionally.
>> > If there is no plan to fix it soon, perhaps the info that is in the
>> > comments should at least be conveyed to users.
>> The introduction of lexical-binding makes this issue more serious
>> because this code does not obey the lexical-binding variable (and
>> escapes the sanity checks of cconv.el, hence occasionally hiding
>> problems when converting to lexical-binding).
> So will this be fixed in Emacs 24.1 then?  +1

No.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#9712; Package emacs. Full text available.

Message received at 9712 <at> debbugs.gnu.org:


Received: (at 9712) by debbugs.gnu.org; 11 Oct 2011 05:40:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 11 01:40:55 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RDV5C-00030s-Dx
	for submit <at> debbugs.gnu.org; Tue, 11 Oct 2011 01:40:55 -0400
Received: from acsinet15.oracle.com ([141.146.126.227])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <drew.adams@HIDDEN>) id 1RDV59-00030f-ML
	for 9712 <at> debbugs.gnu.org; Tue, 11 Oct 2011 01:40:52 -0400
Received: from ucsinet23.oracle.com (ucsinet23.oracle.com [156.151.31.71])
	by acsinet15.oracle.com (Switch-3.4.4/Switch-3.4.4) with ESMTP id
	p9B5eTgq012707
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=FAIL);
	Tue, 11 Oct 2011 05:40:30 GMT
Received: from acsmt358.oracle.com (acsmt358.oracle.com [141.146.40.158])
	by ucsinet23.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id
	p9B5eSx5027767
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO);
	Tue, 11 Oct 2011 05:40:28 GMT
Received: from abhmt109.oracle.com (abhmt109.oracle.com [141.146.116.61])
	by acsmt358.oracle.com (8.12.11.20060308/8.12.11) with ESMTP id
	p9B5eMWI020684; Tue, 11 Oct 2011 00:40:22 -0500
Received: from dradamslap1 (/10.159.50.234)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Mon, 10 Oct 2011 22:40:22 -0700
From: "Drew Adams" <drew.adams@HIDDEN>
To: "'Stefan Monnier'" <monnier@HIDDEN>
References: <F53B306DF56A443A953E84CE5AFA8D33@HIDDEN><jwvy5ws2rz0.fsf-monnier+emacs@HIDDEN><7D2DB4482840400D81CC74F60D0091DC@HIDDEN>
	<jwvsjn0yv3l.fsf-monnier+emacs@HIDDEN>
Subject: RE: bug#9712: 24.0.50; doc about byte-compiling `defcustom'
Date: Mon, 10 Oct 2011 22:40:19 -0700
Message-ID: <E46291070877490CB64D692C8E3D00C8@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
In-Reply-To: <jwvsjn0yv3l.fsf-monnier+emacs@HIDDEN>
Thread-Index: AcyH0/46vSJx8jt9SrWb2S3ss5a4BQABB7MA
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.6109
X-Source-IP: ucsinet23.oracle.com [156.151.31.71]
X-CT-RefId: str=0001.0A090203.4E93D6CF.002B,ss=1,re=0.000,fgs=0
X-Spam-Score: -6.2 (------)
X-Debbugs-Envelope-To: 9712
Cc: 9712 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.2 (------)

> > The bug has been there for multiple major Emacs releases now -
> > a decade or so, and appears to have been introduced intentionally.
> > If there is no plan to fix it soon, perhaps the info that is in the
> > comments should at least be conveyed to users.
> 
> The introduction of lexical-binding makes this issue more serious
> because this code does not obey the lexical-binding variable (and
> escapes the sanity checks of cconv.el, hence occasionally hiding
> problems when converting to lexical-binding).

So will this be fixed in Emacs 24.1 then?  +1





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#9712; Package emacs. Full text available.

Message received at 9712 <at> debbugs.gnu.org:


Received: (at 9712) by debbugs.gnu.org; 11 Oct 2011 05:10:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 11 01:10:02 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RDUbJ-0002I9-MJ
	for submit <at> debbugs.gnu.org; Tue, 11 Oct 2011 01:10:02 -0400
Received: from ironport2-out.teksavvy.com ([206.248.154.183]
	helo=ironport2-out.pppoe.ca)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <monnier@HIDDEN>) id 1RDUbG-0002Hg-N2
	for 9712 <at> debbugs.gnu.org; Tue, 11 Oct 2011 01:09:59 -0400
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: Av0EALPOk05FxJoX/2dsb2JhbABDqBqBBoFTAQEEAVYjBQsLNBIUGA0kiBG5JYdMBKEdhEU
X-IronPort-AV: E=Sophos;i="4.68,521,1312171200"; d="scan'208";a="141094977"
Received: from 69-196-154-23.dsl.teksavvy.com (HELO ceviche.home)
	([69.196.154.23])
	by ironport2-out.pppoe.ca with ESMTP/TLS/ADH-AES256-SHA;
	11 Oct 2011 01:09:38 -0400
Received: by ceviche.home (Postfix, from userid 20848)
	id D1758660B6; Tue, 11 Oct 2011 01:09:37 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: "Drew Adams" <drew.adams@HIDDEN>
Subject: Re: bug#9712: 24.0.50; doc about byte-compiling `defcustom'
Message-ID: <jwvsjn0yv3l.fsf-monnier+emacs@HIDDEN>
References: <F53B306DF56A443A953E84CE5AFA8D33@HIDDEN>
	<jwvy5ws2rz0.fsf-monnier+emacs@HIDDEN>
	<7D2DB4482840400D81CC74F60D0091DC@HIDDEN>
Date: Tue, 11 Oct 2011 01:09:37 -0400
In-Reply-To: <7D2DB4482840400D81CC74F60D0091DC@HIDDEN> (Drew Adams's
	message of "Mon, 10 Oct 2011 21:51:00 -0700")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.90 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.6 (--)
X-Debbugs-Envelope-To: 9712
Cc: 9712 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.6 (--)

>> The bug is not in the doc but in the behavior.
> That was my feeling, as well.  But I did not expect agreement, based on the
> commented code.

> The bug has been there for multiple major Emacs releases now -
> a decade or so, and appears to have been introduced intentionally.
> If there is no plan to fix it soon, perhaps the info that is in the
> comments should at least be conveyed to users.

The introduction of lexical-binding makes this issue more serious
because this code does not obey the lexical-binding variable (and
escapes the sanity checks of cconv.el, hence occasionally hiding
problems when converting to lexical-binding).

> Alternatively, the code could be uncommented and byte-compiling be let free to
> do what is advertised that it does.  The downside would be showing users the
> constant values in Customize, but that seems like less of a disfunction than
> what we have now.

We need to solve the display issue some other way, yes.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#9712; Package emacs. Full text available.

Message received at 9712 <at> debbugs.gnu.org:


Received: (at 9712) by debbugs.gnu.org; 11 Oct 2011 04:51:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 11 00:51:35 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RDUJS-0001qw-IF
	for submit <at> debbugs.gnu.org; Tue, 11 Oct 2011 00:51:35 -0400
Received: from rcsinet15.oracle.com ([148.87.113.117])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <drew.adams@HIDDEN>) id 1RDUJQ-0001qh-6Q
	for 9712 <at> debbugs.gnu.org; Tue, 11 Oct 2011 00:51:32 -0400
Received: from acsinet22.oracle.com (acsinet22.oracle.com [141.146.126.238])
	by rcsinet15.oracle.com (Switch-3.4.4/Switch-3.4.4) with ESMTP id
	p9B4p9ne015166
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
	Tue, 11 Oct 2011 04:51:11 GMT
Received: from acsmt358.oracle.com (acsmt358.oracle.com [141.146.40.158])
	by acsinet22.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id
	p9B4p9ov004614
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO);
	Tue, 11 Oct 2011 04:51:09 GMT
Received: from abhmt119.oracle.com (abhmt119.oracle.com [141.146.116.71])
	by acsmt358.oracle.com (8.12.11.20060308/8.12.11) with ESMTP id
	p9B4p3IS026669; Mon, 10 Oct 2011 23:51:03 -0500
Received: from dradamslap1 (/10.159.50.234)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Mon, 10 Oct 2011 21:51:03 -0700
From: "Drew Adams" <drew.adams@HIDDEN>
To: "'Stefan Monnier'" <monnier@HIDDEN>
References: <F53B306DF56A443A953E84CE5AFA8D33@HIDDEN>
	<jwvy5ws2rz0.fsf-monnier+emacs@HIDDEN>
Subject: RE: bug#9712: 24.0.50; doc about byte-compiling `defcustom'
Date: Mon, 10 Oct 2011 21:51:00 -0700
Message-ID: <7D2DB4482840400D81CC74F60D0091DC@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
In-Reply-To: <jwvy5ws2rz0.fsf-monnier+emacs@HIDDEN>
Thread-Index: AcyHu/NzbqB2H97tTm+GdMR/1HsdugAFBKEA
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.6109
X-Source-IP: acsinet22.oracle.com [141.146.126.238]
X-Auth-Type: Internal IP
X-CT-RefId: str=0001.0A090206.4E93CB3F.0113:SCFMA922111,ss=1,re=-4.000,fgs=0
X-Spam-Score: -6.2 (------)
X-Debbugs-Envelope-To: 9712
Cc: 9712 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.2 (------)

> The bug is not in the doc but in the behavior.

That was my feeling, as well.  But I did not expect agreement, based on the
commented code.

The bug has been there for multiple major Emacs releases now - a decade or so,
and appears to have been introduced intentionally.  If there is no plan to fix
it soon, perhaps the info that is in the comments should at least be conveyed to
users.

Alternatively, the code could be uncommented and byte-compiling be let free to
do what is advertised that it does.  The downside would be showing users the
constant values in Customize, but that seems like less of a disfunction than
what we have now.

As it stands now, the behavior is stable (many years), but it is not what is
intended and it does not correspond to the behavior implied by the doc.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#9712; Package emacs. Full text available.
Changed bug title to 'defcustom's initial value expression is not byte-compiled' from '24.0.50; doc about byte-compiling `defcustom'' Request was from Stefan Monnier <monnier@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 9712 <at> debbugs.gnu.org:


Received: (at 9712) by debbugs.gnu.org; 11 Oct 2011 02:17:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 10 22:17:52 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RDRuh-0005J3-7B
	for submit <at> debbugs.gnu.org; Mon, 10 Oct 2011 22:17:51 -0400
Received: from ironport2-out.teksavvy.com ([206.248.154.183]
	helo=ironport2-out.pppoe.ca)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <monnier@HIDDEN>)
	id 1RDRuf-0005Ip-Tt; Mon, 10 Oct 2011 22:17:50 -0400
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: Av0EAOylk05FxJoX/2dsb2JhbABDqBqBBoFTAQEEAVYjBQsLNBIUGA0kiBG6BYdMBKEdhEU
X-IronPort-AV: E=Sophos;i="4.68,520,1312171200"; d="scan'208";a="141054934"
Received: from 69-196-154-23.dsl.teksavvy.com (HELO ceviche.home)
	([69.196.154.23])
	by ironport2-out.pppoe.ca with ESMTP/TLS/ADH-AES256-SHA;
	10 Oct 2011 22:17:29 -0400
Received: by ceviche.home (Postfix, from userid 20848)
	id 490C5660B6; Mon, 10 Oct 2011 22:17:29 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: "Drew Adams" <drew.adams@HIDDEN>
Subject: Re: bug#9712: 24.0.50; doc about byte-compiling `defcustom'
Message-ID: <jwvy5ws2rz0.fsf-monnier+emacs@HIDDEN>
References: <F53B306DF56A443A953E84CE5AFA8D33@HIDDEN>
Date: Mon, 10 Oct 2011 22:17:29 -0400
In-Reply-To: <F53B306DF56A443A953E84CE5AFA8D33@HIDDEN> (Drew Adams's
	message of "Sun, 9 Oct 2011 13:42:47 -0700")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.90 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.6 (--)
X-Debbugs-Envelope-To: 9712
Cc: 9712 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.6 (--)

retitle 9712 defcustom's initial value expression is not byte-compiled
thanks

> This is what the byte-compiled file shows:
 
> #@14 jjjjjjjjjjjj
> (custom-declare-variable 'titi '(eval-when-compile
>   `(,(kbd "S-<tab>"))) '(#$ . 509) :type '(repeat sexp) :group 'edit)
> #@12 kkkkkkkkkk
> (defvar toto '([S-tab]) (#$ . 647))
 
> Here's the bug (a doc bug), as I see it: Where in the doc is this
> behavior described?  Where does it say that the STANDARD arg to
> defcustom is not evaluated by the byte compiler, even when you use
> `eval-when-compile'?
 
The bug is not in the doc but in the behavior.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#9712; Package emacs. Full text available.

Message received at 9712 <at> debbugs.gnu.org:


Received: (at 9712) by debbugs.gnu.org; 10 Oct 2011 22:39:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 10 18:39:28 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RDOVL-00080x-Pf
	for submit <at> debbugs.gnu.org; Mon, 10 Oct 2011 18:39:28 -0400
Received: from acsinet15.oracle.com ([141.146.126.227])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <drew.adams@HIDDEN>) id 1RDOVI-00080k-CI
	for 9712 <at> debbugs.gnu.org; Mon, 10 Oct 2011 18:39:25 -0400
Received: from acsinet22.oracle.com (acsinet22.oracle.com [141.146.126.238])
	by acsinet15.oracle.com (Switch-3.4.4/Switch-3.4.4) with ESMTP id
	p9AMd2Ft018136
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK)
	for <9712 <at> debbugs.gnu.org>; Mon, 10 Oct 2011 22:39:03 GMT
Received: from acsmt358.oracle.com (acsmt358.oracle.com [141.146.40.158])
	by acsinet22.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id
	p9AMd1vH002874
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO)
	for <9712 <at> debbugs.gnu.org>; Mon, 10 Oct 2011 22:39:02 GMT
Received: from abhmt109.oracle.com (abhmt109.oracle.com [141.146.116.61])
	by acsmt358.oracle.com (8.12.11.20060308/8.12.11) with ESMTP id
	p9AMctMc018765
	for <9712 <at> debbugs.gnu.org>; Mon, 10 Oct 2011 17:38:56 -0500
Received: from dradamslap1 (/130.35.178.194)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Mon, 10 Oct 2011 15:38:55 -0700
From: "Drew Adams" <drew.adams@HIDDEN>
To: <9712 <at> debbugs.gnu.org>
References: <F53B306DF56A443A953E84CE5AFA8D33@HIDDEN><5316997534F141EBA11CE740B68DCD49@HIDDEN>
	<26A045CF2B45494A9C953D8E1830C447@HIDDEN>
Subject: RE: bug#9712: 24.0.50; doc about byte-compiling `defcustom'
Date: Mon, 10 Oct 2011 15:38:59 -0700
Message-ID: <C6C294B291364707A6AFED5EBDB32A1F@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
In-Reply-To: <26A045CF2B45494A9C953D8E1830C447@HIDDEN>
Thread-Index: AcyGxABySUCCOc7CRFmaFVEYHb26SgAiuF8gAAUS5YAADl2rsA==
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.6109
X-Source-IP: acsinet22.oracle.com [141.146.126.238]
X-Auth-Type: Internal IP
X-CT-RefId: str=0001.0A090208.4E937408.00D5:SCFMA922111,ss=1,re=-4.000,fgs=0
X-Spam-Score: -6.2 (------)
X-Debbugs-Envelope-To: 9712
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.2 (------)

If, as the comment in the code suggests, the aim in commenting out the code
(that would otherwise let the byte-compiler eval the defcustom value and assign
the result as a constant in the compiled code) is to avoid having users see the
byte-compiled value in Customize buffers, then why not solve both problems
instead of choosing one or the other?

Byte-compiling should, as is everywhere claimed (e.g., the doc), replace the
VALUE with its evaluation, as a constant, in the byte-compiled code.  But
nothing prevents saving the Lisp sexp that evaluates to that constant.  And
nothing then prevents making that saved sexp available to the user in Customize.
We could even let the user see both: the value and the sexp that eval'd to it.

And most evaluation of a defcustom value leads to a normal Lisp object that
users are used to seeing anyway (string, number,...).

Was there some other reason, besides not having the user see the sexp's value,
for not letting the byte-compiler treat the defcustom VALUE normally?





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#9712; Package emacs. Full text available.

Message received at 9712 <at> debbugs.gnu.org:


Received: (at 9712) by debbugs.gnu.org; 10 Oct 2011 15:53:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 10 11:53:45 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RDIAi-0005UO-5k
	for submit <at> debbugs.gnu.org; Mon, 10 Oct 2011 11:53:45 -0400
Received: from acsinet15.oracle.com ([141.146.126.227])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <drew.adams@HIDDEN>) id 1RDIAf-0005U7-2T
	for 9712 <at> debbugs.gnu.org; Mon, 10 Oct 2011 11:53:42 -0400
Received: from ucsinet23.oracle.com (ucsinet23.oracle.com [156.151.31.71])
	by acsinet15.oracle.com (Switch-3.4.4/Switch-3.4.4) with ESMTP id
	p9AFrLwP032189
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=FAIL)
	for <9712 <at> debbugs.gnu.org>; Mon, 10 Oct 2011 15:53:23 GMT
Received: from acsmt357.oracle.com (acsmt357.oracle.com [141.146.40.157])
	by ucsinet23.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id
	p9AFrKgp025468
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO)
	for <9712 <at> debbugs.gnu.org>; Mon, 10 Oct 2011 15:53:21 GMT
Received: from abhmt105.oracle.com (abhmt105.oracle.com [141.146.116.57])
	by acsmt357.oracle.com (8.12.11.20060308/8.12.11) with ESMTP id
	p9AFrFXA006457
	for <9712 <at> debbugs.gnu.org>; Mon, 10 Oct 2011 10:53:15 -0500
Received: from dradamslap1 (/130.35.178.194)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Mon, 10 Oct 2011 08:53:14 -0700
From: "Drew Adams" <drew.adams@HIDDEN>
To: <9712 <at> debbugs.gnu.org>
References: <F53B306DF56A443A953E84CE5AFA8D33@HIDDEN>
	<5316997534F141EBA11CE740B68DCD49@HIDDEN>
Subject: RE: bug#9712: 24.0.50; doc about byte-compiling `defcustom'
Date: Mon, 10 Oct 2011 08:53:15 -0700
Message-ID: <26A045CF2B45494A9C953D8E1830C447@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
In-Reply-To: <5316997534F141EBA11CE740B68DCD49@HIDDEN>
Thread-Index: AcyGxABySUCCOc7CRFmaFVEYHb26SgAiuF8gAAUS5YA=
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.6109
X-Source-IP: ucsinet23.oracle.com [156.151.31.71]
X-CT-RefId: str=0001.0A020203.4E9314F3.009F,ss=1,re=0.000,fgs=0
X-Spam-Score: -6.2 (------)
X-Debbugs-Envelope-To: 9712
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.2 (------)

> A consequence of the current behavior is that you really 
> cannot use macro calls in VALUE, unless you are sure that
> the macro definition will be available also
> at load time (i.e., byte-compilation time is not enough).  I 
> ran into this using macro `kbd' in VALUE.

To clarify: using macro `icicle-kbd', which is similar to `kbd'.  The problem
presumably would not occur for `kbd' itself because it is in `subr.el', which is
always loaded.

E.g., put this in file throw-1.el:
(defcustom foo (eval-when-compile (toto 4))
  "jjjj" :type 'integer :group 'edit)

Put this in file throw-2.el, and evaluate it to define `toto':
(defmacro toto (n) `,n)

Byte-compile throw-1.el.

emacs -Q
M-x load-file throw-1.elc

Error: Symbol's function definition is void: toto.

Bummer.  I would think that byte-compiling would expand and evaluate macros, so
that the file defining the macros would not be needed at load/runtime if the
byte-compiled file is available.  I would expect that to be the case even
without the `eval-when-compile' (which is a specific directive to the
byte-compiler to eval and replace with the value).





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#9712; Package emacs. Full text available.

Message received at 9712 <at> debbugs.gnu.org:


Received: (at 9712) by debbugs.gnu.org; 10 Oct 2011 13:27:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 10 09:27:40 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RDFtM-0001sr-6R
	for submit <at> debbugs.gnu.org; Mon, 10 Oct 2011 09:27:40 -0400
Received: from rcsinet15.oracle.com ([148.87.113.117])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <drew.adams@HIDDEN>) id 1RDFtJ-0001se-3z
	for 9712 <at> debbugs.gnu.org; Mon, 10 Oct 2011 09:27:38 -0400
Received: from acsinet21.oracle.com (acsinet21.oracle.com [141.146.126.237])
	by rcsinet15.oracle.com (Switch-3.4.4/Switch-3.4.4) with ESMTP id
	p9ADRHvl032345
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK)
	for <9712 <at> debbugs.gnu.org>; Mon, 10 Oct 2011 13:27:19 GMT
Received: from acsmt357.oracle.com (acsmt357.oracle.com [141.146.40.157])
	by acsinet21.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id
	p9ADRGtR010491
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO)
	for <9712 <at> debbugs.gnu.org>; Mon, 10 Oct 2011 13:27:17 GMT
Received: from abhmt108.oracle.com (abhmt108.oracle.com [141.146.116.60])
	by acsmt357.oracle.com (8.12.11.20060308/8.12.11) with ESMTP id
	p9ADRBco021113
	for <9712 <at> debbugs.gnu.org>; Mon, 10 Oct 2011 08:27:11 -0500
Received: from dradamslap1 (/10.159.51.16)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Mon, 10 Oct 2011 06:27:11 -0700
From: "Drew Adams" <drew.adams@HIDDEN>
To: <9712 <at> debbugs.gnu.org>
References: <F53B306DF56A443A953E84CE5AFA8D33@HIDDEN>
Subject: RE: bug#9712: 24.0.50; doc about byte-compiling `defcustom'
Date: Mon, 10 Oct 2011 06:27:14 -0700
Message-ID: <5316997534F141EBA11CE740B68DCD49@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
In-Reply-To: <F53B306DF56A443A953E84CE5AFA8D33@HIDDEN>
Thread-Index: AcyGxABySUCCOc7CRFmaFVEYHb26SgAiuF8g
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.6109
X-Source-IP: acsinet21.oracle.com [141.146.126.237]
X-Auth-Type: Internal IP
X-CT-RefId: str=0001.0A090209.4E92F2B7.0213:SCFMA922111,ss=1,re=-4.000,fgs=0
X-Spam-Score: -6.2 (------)
X-Debbugs-Envelope-To: 9712
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.2 (------)

Is this maybe more than a doc bug?  In bytecomp.el there is this:

(defun byte-compile-file-form-custom-declare-variable (form)
  (when (byte-compile-warning-enabled-p 'callargs)
    (byte-compile-nogroup-warn form))
  (push (nth 1 (nth 1 form)) byte-compile-bound-variables)
  ;; Don't compile the expression because it may be displayed to the user.
  ;; (when (eq (car-safe (nth 2 form)) 'quote)
  ;;   ;; (nth 2 form) is meant to evaluate to an expression, so if we have the
  ;;   ;; final value already, we can byte-compile it.
  ;;   (setcar (cdr (nth 2 form))
  ;;           (byte-compile-top-level (cadr (nth 2 form)) nil 'file)))

Seems like this non-evaluation is intended, but sounds like the designer is not
sure that's a good idea (?).  What does "because it may be displayed to the
user" mean?  Is the idea that the user would see the byte-compiled value instead
of the code that evaluates to that value?  If so, why is that bad?

At any rate, there is at least a doc bug.  In particular, someone who wraps the
`defcustom' VALUE in `eval-when-compile' will mistakenly expect the evaluation
result to be placed into the byte code as a constant.  S?he will not expect that
VALUE is not evaluated at byte-compile time, even when inside
`eval-when-compile'.

A consequence of the current behavior is that you really cannot use macro calls
in VALUE, unless you are sure that the macro definition will be available also
at load time (i.e., byte-compilation time is not enough).  I ran into this using
macro `kbd' in VALUE.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#9712; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 9 Oct 2011 20:43:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 09 16:43:16 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RD0DL-0001f3-Rs
	for submit <at> debbugs.gnu.org; Sun, 09 Oct 2011 16:43:16 -0400
Received: from eggs.gnu.org ([140.186.70.92])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <drew.adams@HIDDEN>) id 1RD0DI-0001eo-QL
	for submit <at> debbugs.gnu.org; Sun, 09 Oct 2011 16:43:14 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <drew.adams@HIDDEN>) id 1RD0D4-0006X1-Tl
	for submit <at> debbugs.gnu.org; Sun, 09 Oct 2011 16:42:59 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.1 (2010-03-16) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-4.7 required=5.0 tests=BAYES_00,RCVD_IN_DNSWL_MED,
	RP_MATCHES_RCVD,UNPARSEABLE_RELAY autolearn=unavailable version=3.3.1
Received: from lists.gnu.org ([140.186.70.17]:56053)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <drew.adams@HIDDEN>) id 1RD0D4-0006Wx-SK
	for submit <at> debbugs.gnu.org; Sun, 09 Oct 2011 16:42:58 -0400
Received: from eggs.gnu.org ([140.186.70.92]:37223)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <drew.adams@HIDDEN>) id 1RD0D3-00007N-Lk
	for bug-gnu-emacs@HIDDEN; Sun, 09 Oct 2011 16:42:58 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <drew.adams@HIDDEN>) id 1RD0D2-0006WX-AD
	for bug-gnu-emacs@HIDDEN; Sun, 09 Oct 2011 16:42:57 -0400
Received: from rcsinet15.oracle.com ([148.87.113.117]:41728)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <drew.adams@HIDDEN>) id 1RD0D2-0006WR-5A
	for bug-gnu-emacs@HIDDEN; Sun, 09 Oct 2011 16:42:56 -0400
Received: from acsinet22.oracle.com (acsinet22.oracle.com [141.146.126.238])
	by rcsinet15.oracle.com (Switch-3.4.4/Switch-3.4.4) with ESMTP id
	p99Kgqmq017080
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK)
	for <bug-gnu-emacs@HIDDEN>; Sun, 9 Oct 2011 20:42:54 GMT
Received: from acsmt358.oracle.com (acsmt358.oracle.com [141.146.40.158])
	by acsinet22.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id
	p99Kgq5D013336
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO)
	for <bug-gnu-emacs@HIDDEN>; Sun, 9 Oct 2011 20:42:52 GMT
Received: from abhmt107.oracle.com (abhmt107.oracle.com [141.146.116.59])
	by acsmt358.oracle.com (8.12.11.20060308/8.12.11) with ESMTP id
	p99Kgkur004777
	for <bug-gnu-emacs@HIDDEN>; Sun, 9 Oct 2011 15:42:46 -0500
Received: from dradamslap1 (/10.159.58.246)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Sun, 09 Oct 2011 13:42:46 -0700
From: "Drew Adams" <drew.adams@HIDDEN>
To: <bug-gnu-emacs@HIDDEN>
Subject: 24.0.50; doc about byte-compiling `defcustom'
Date: Sun, 9 Oct 2011 13:42:47 -0700
Message-ID: <F53B306DF56A443A953E84CE5AFA8D33@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: quoted-printable
X-Mailer: Microsoft Office Outlook 11
Thread-Index: AcyGxABySUCCOc7CRFmaFVEYHb26Sg==
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.6109
X-Source-IP: acsinet22.oracle.com [141.146.126.238]
X-Auth-Type: Internal IP
X-CT-RefId: str=0001.0A090204.4E92074E.0073:SCFMA922111,ss=1,re=-4.000,fgs=0
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6 (newer, 1)
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6 (newer, 3)
X-Received-From: 140.186.70.17
X-Spam-Score: -6.2 (------)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.2 (------)

Put this in a file foo.el, and byte-compile the file:
=20
(defcustom titi (eval-when-compile `(,(kbd "S-<tab>")))
  "jjjjjjjjjjjj"
  :type '(repeat sexp) :group 'edit)
=20
(defvar toto (eval-when-compile `(,(kbd "S-<tab>")))
 "kkkkkkkkkk")
=20
This is what the byte-compiled file shows:
=20
#@14 jjjjjjjjjjjj=1F
(custom-declare-variable 'titi '(eval-when-compile
  `(,(kbd "S-<tab>"))) '(#$ . 509) :type '(repeat sexp) :group 'edit)
#@12 kkkkkkkkkk=1F
(defvar toto '([S-tab]) (#$ . 647))
=20
Here's the bug (a doc bug), as I see it: Where in the doc is this
behavior described?  Where does it say that the STANDARD arg to
defcustom is not evaluated by the byte compiler, even when you use
`eval-when-compile'?
=20
(elisp) Variable Definitions says this, but it's about all I can find:
=20
"Evaluating the `defcustom' form evaluates STANDARD, but does not
necessarily install the standard value."
=20
And of course the doc for `eval-when-compile', (elisp) `Eval During
Compile', says "The result of evaluation by the compiler becomes a
constant which appears in the compiled program."
=20
I see it documented nowhere that the STANDARD arg to defcustom appears
unevaluated in byte-compiled code.
=20
=20
=20
In GNU Emacs 24.0.50.1 (i386-mingw-nt5.1.2600)
 of 2011-09-19 on 3249CTO
Windowing system distributor `Microsoft Corp.', version 5.1.2600
configured using `configure --with-gcc (4.5) --no-opt'
=20





Acknowledgement sent to "Drew Adams" <drew.adams@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#9712; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Fri, 31 Oct 2014 17:00:04 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.